/*
 * sfas-field.h
 * Copyright (C) 2009-2013, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_sfas_field_H__
#define __LIBx1f4_sfas_field_H__

#include <string.h>

#include <sfas-types.h>

#define advance_node(___f, ___s, ___l) \
    {									      \
	unsigned bits;							      \
									      \
	bits = (___f)->bits;						      \
	forward_node((___f), (___s), (___l), bits);			      \
    }

#define forward_node(___f, ___s, ___l, ___b) \
    {									      \
	(___l) = Length((___b));					      \
	if (Extant((___b))) {						      \
	    if (sizeof(byte *) < (___l)) {				      \
		(___s) = (___f)->base;					      \
		if ((___l) < Record) {					      \
		} else {						      \
		    (___l) += strlen((char *) (___s) + Record);		      \
		}							      \
	    } else {							      \
		(___s) = (byte *) &(___f)->base;			      \
	    }								      \
	} else {							      \
	    unsigned offset;						      \
									      \
	    (___s) = (___f)->base;					      \
									      \
	    if ((___l) < Record) {					      \
	    } else {							      \
		(___l) += strlen((char *) (___s) + Record);		      \
	    }								      \
									      \
	    offset = name - lead;					      \
	    (___s) += offset;						      \
	    (___l) -= offset;						      \
	}								      \
    }

#endif				/* __LIBx1f4_sfas_field_H__ */
